/*>>keyflag<< "%n"***********************************************************
  "NOTES.C"
  
  Copyright (c) 1995 Pixel Translations, Incorporated.
  All Rights Reserved.
  Confidential and Proprietary to Pixel Translations, Incorporated.
  
*****************************************************************************
  TLIB Keywords: %v=version, %d=file date, %f=file date and time, %t=time
                 %w=who last, %l=lock status, %n=file name
*****************************************************************************/


/*>>keyflag<< * %n %f %l **/
/* NOTES.C 26-Oct-95,10:58:40  */

#ifndef __TLIB_ID__
#ifdef DEBUG
/*>>keyflag<< "&(#)%n v%v %f Debug" */
static char szVersionId[] = "&(#)NOTES.C v16 26-Oct-95,10:58:40 Debug";
#else
/*>>keyflag<< "&(#)%n v%v %f" */
static char szVersionId[] = "&(#)NOTES.C v16 26-Oct-95,10:58:40";
#endif
#define __TLIB_ID__
#endif

typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long LWRD;

#define MAXFNAME 80
#define MAX_HNDL 10

#include <windows.h>
#include <commdlg.h>
#include <pixdflt.h>
#include <pixm.h>
#include <PixIF.h>
#include <PixFile.h>
#include <PixNote.h>
#include "SmplView.h"

/**From SMPLVIEW.C**/
extern HINSTANCE hInst;
extern PIXM_PAGE mPage;
extern PIXM_SETTINGS pSettings;
extern HWND hWndMain;

PIXNOTE_HNDL NoteHndl[MAX_HNDL];
PIXNOTE_ENV NoteInstance;

static int  CmdOpen(HWND hWnd, WORD IsNew);
static int  CmdSave(HWND hWnd);
static int  CmdClose(HWND hWnd);
static int  CmdEdit(HWND hWnd);
static int  GetNewFName(HWND hWnd, WORD Saving);
static int  DoOpenNote(HWND hWnd, WORD IsNew);
static int  MaybeClose(HWND hWnd, WORD DoSave, WORD DoClose);
static void RepaintScrn(HWND hWnd);

//static BYTE NotesFName[MAXFNAME]= {"TEST.NOT"};
static BYTE NotesFName[MAXFNAME]= "";
static BYTE NotesFilters[]= {
	"Notes (*.NOT)\0" "*.NOT\0"
	"Any file (*.*)\0" "*.*\0"
	"\0\0"
};

int ProcessNoteCmd(HWND hWnd, WPARAM CmdID, LPARAM Arg) {
	switch(CmdID) {
	case IDM_N_NEW:		return CmdOpen(hWnd,1); break;
	case IDM_N_LOAD:	return CmdOpen(hWnd,0); break;
	case IDM_N_EDIT:	return CmdEdit(hWnd); break;
	case IDM_N_SAVE:	return CmdSave(hWnd); break;
	case IDM_N_CLOSE:	return CmdClose(hWnd); break;
	case IDM_N_REDRAW:	RepaintScrn(hWnd); break;
	}
	return 0;
}

static int CmdOpen(HWND hWnd, WORD IsNew) {
	int Err=0;
	
	if(NoteHndl[0])
		Err= MaybeClose(hWnd,1,0);
	if(!Err) {
		if(IsNew) {
			Err = MaybeClose(hWnd, 0, 1);
			if (!Err)
				NotesFName[0]= 0;
		} else {
			BYTE StoreFName[MAXFNAME];
			_fmemcpy(StoreFName, NotesFName, sizeof(NotesFName));
			Err= GetNewFName(hWnd,0);
			if (Err) {
				_fmemcpy(NotesFName, StoreFName, sizeof(NotesFName));
			} else {
				Err = MaybeClose(hWnd, 0, 1);
			}
		}
		if(!Err)
			Err= DoOpenNote(hWnd,IsNew);
			
		if (Err) {
			NotesFName[0] = 0;
			MessageBox(0, "Could not load annotation file.", 0, MB_TASKMODAL | MB_OK);
		} else if(NoteHndl[0])
			RepaintScrn(hWnd);
	}
	return(Err);
}

/*************************************************************************/
/** int CmdSave(hWnd,AsNewName)								17Feb94 CHP	**/
/** --	This is called in response to the menu item "File/Save" or		**/
/**		"File/Save as...". If AsNewName is NZ, the user should be		**/
/**		prompted to select a new filename.								**/
/*************************************************************************/
static int CmdSave(HWND hWnd) {
	int Err= 0;
	if(NoteHndl[0]) {
		if(!*NotesFName)
			Err= GetNewFName(hWnd,1);
		if(!Err)
			Err= PixNoteSave(NoteHndl[0],NotesFName,PNF_FORMAT_DBG);
	}
	return(Err);
}

static int GetNewFName(HWND hWnd, WORD Saving) {
	OPENFILENAME Info;
	int Err= 0;
	Info.lStructSize= sizeof(Info);
	Info.hwndOwner= hWnd;
	Info.hInstance= hInst;
	Info.lpstrFilter= NotesFilters;
	Info.lpstrCustomFilter= 0;
	Info.nMaxCustFilter= 0;
	Info.nFilterIndex= 0;
	Info.lpstrFile= NotesFName;
	Info.nMaxFile= MAXFNAME;
	Info.lpstrFileTitle= 0;
	Info.nMaxFileTitle= 0;
	Info.lpstrInitialDir= 0;
	Info.lpstrTitle= Saving ? "Save Annotation Files":"Load Annotation Files";
	Info.Flags= OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST;
	Info.nFileOffset= 0;
	Info.nFileExtension= 0;
	Info.lpstrDefExt= "NOT";
	Info.lCustData= 0;
	Info.lpfnHook= 0;
	Info.lpTemplateName= 0;
	if(Saving)
		Err= !GetSaveFileName(&Info);
	else
		Err= !GetOpenFileName(&Info);
	return(Err);
}

static int CmdClose(HWND hWnd) {
	WORD bMod = FALSE;
	int Err=0;
	if(NoteHndl[0]) {
		if(!PixNoteIsModified(NoteHndl[0], &bMod) && bMod) {
			switch (MessageBox(hWnd, (LPSTR)"Annotations have been modified."
												 "Would you like to save them?", (LPSTR)"SmplView",
												 MB_YESNOCANCEL)) {
			case IDNO:
				break;
			case IDYES:
				Err = CmdSave(hWnd);
				break;
			case IDCANCEL:
			default:
				Err = -1;
				break;
			}
		}
		if (!Err) {
			if(!(Err= PixNoteFree(NoteHndl[0],1)))
				NoteHndl[0]= 0;
		}
	}
	RepaintScrn(hWnd);
	return(Err);
}

static int CmdEdit(HWND hWnd) {
	int Err=0;
	if(!NoteHndl[0]) {
		NotesFName[0]= 0;
		DoOpenNote(hWnd,1);
	}
	if(NoteHndl[0]) {
		Err= PixNoteEdit(NoteHndl[0],hWnd,hInst,0);
		RepaintScrn(hWnd);
	}
	return(Err);
}

static int DoOpenNote(HWND hWnd, WORD IsNew) {
	int Err;
	Err= PixNoteNew(NoteInstance,&NoteHndl[0]);
	if(!Err && !IsNew)
		Err= PixNoteLoad(NoteHndl[0],NotesFName,PNF_FORMAT_DBG);
	return(Err);
}

static int MaybeClose(HWND hWnd, WORD DoSave, WORD DoClose) {
	int Err=0;
	long lVal;
	WORD bMod = FALSE;
	if(NoteHndl[0]) {
		PixNoteIsModified(NoteHndl[0], &bMod);
	}
	if (!bMod)
		DoSave = 0;
	if(NoteHndl[0]) {
		if(DoSave && bMod) {
			switch (MessageBox(hWnd, (LPSTR)"Save current annotations first?",
				(LPSTR)"SmplView", MB_YESNOCANCEL)) {
				case IDNO:
					DoSave = 0;
					break;
				case IDYES:
					break;
				case IDCANCEL:
				default:
					DoSave = 0;
					DoClose = 0;
					Err = -1;
					break;
			}
		}
		if (DoSave) {
			if(!*NotesFName)
				Err= GetNewFName(hWnd,1);
			if(!Err)
				Err= PixNoteGet(NoteHndl[0],PNG_MODIFIED,&lVal);
			if(!Err && lVal)
				Err= PixNoteSave(NoteHndl[0],NotesFName,PNF_FORMAT_DBG);
		}
		if(!Err && DoClose) {
			if(!(Err= PixNoteFree(NoteHndl[0],1)))
				NoteHndl[0]= 0;
		}
	}
	return(Err);
}

static void RepaintScrn(HWND hWnd) {
	InvalidateRect(hWnd,0,1);
}

/*************************************************************************/
/** PIXIF test routines.												**/
/*************************************************************************/
int ReadAnnotations(BYTE FAR *FName, PIXM_PAGE hPage) {
	int Err;
	WORD TotItems=0;
	PIXNOTE_HNDL HndlID;
	HDC Scrn;
//    PIXNOTE_ITEM Item;

	if(NoteHndl[0]) {
		PixNoteFree(NoteHndl[0],1);
		NoteHndl[0]= 0;
	}
	Err= PixNoteNew(NoteInstance,&HndlID);
	if(!Err) {
		Err= PixNoteLoadFileIF(HndlID,FName,1);
#ifdef DEBUG
		    if (!Err) {

			LOGFONT PopUpFont = { 15, 0, 0, 0, 700, 1, 0, 0, 0, 3, 2, 1, 49, "Courier New" };
			LOGFONT TextFont = { 45, 0, 0, 0, 700, 0, 0, 0, 0, 3, 2, 1, 49, "Arial" };

//			Err = PixNoteItemNew(HndlID, &Item, NOTE_MODE_HILITE);
//			Err = PixNoteItemSet(Item, PNI_ANCHOR, 0, MAKELONG(100,100));
//			Err = PixNoteItemSet(Item, PNI_BBOX_RIGHT, 0, MAKELONG(0,-0));
//			Err = PixNoteItemSet(Item, PNI_BBOX_LEFT, 0, MAKELONG(-100,-100));
//			Err = PixNoteItemAdd(HndlID, Item, 0);
//			Err = PixNoteItemSet(Item, PNI_COLOR, 0, RGB(128,0,128));

//			Err = PixNoteItemSetDefault(NOTE_MODE_HILITE, PNI_COLOR, 0, RGB(128,0,0));

//			Err = PixNoteItemNew(HndlID, &Item, NOTE_MODE_HILITE);
//			Err = PixNoteItemSet(Item, PNI_ANCHOR, 0, MAKELONG(200,200));
//			Err = PixNoteItemSet(Item, PNI_BBOX_RIGHT, 0, MAKELONG(0,0));
//			Err = PixNoteItemSet(Item, PNI_BBOX_LEFT, 0, MAKELONG(100,100));
//			Err = PixNoteItemAdd(HndlID, Item, 0);
//			Err = PixNoteItemSet(Item, PNI_COLOR, 0, RGB(128,0,0));

			Err = PixNoteItemNew(HndlID, &Item, NOTE_MODE_TEXT);
			Err = PixNoteItemSet(Item, PNI_ANCHOR, 0, MAKELONG(300,100));
			Err = PixNoteItemSet(Item, PNI_TEXT, 0, (LWRD)(char FAR *)"This is a text test");
			Err = PixNoteItemSet(Item, PNI_APPENDTEXT, 0, (LWRD)(char FAR*)"\rAnother line");
			Err = PixNoteItemAdd(HndlID, Item, 0);
			Err = PixNoteItemSet(Item, PNI_COLOR, 0, RGB(128,0,0));

			PixNoteItemSetDefault(NOTE_MODE_TEXT, PNI_TEXT, 0, (LWRD)(char FAR *)"Default text");
//			PixNoteItemSetDefault(NOTE_MODE_TEXT, PNI_FONT, 0, (LWRD)&TextFont);

			Err = PixNoteItemNew(HndlID, &Item, NOTE_MODE_TEXT);
			Err = PixNoteItemSet(Item, PNI_ANCHOR, 0, MAKELONG(300,100));
//			Err = PixNoteItemSet(Item, PNI_TEXT, 0, (LWRD)(char FAR *)"This is a text test");
			Err = PixNoteItemSet(Item, PNI_APPENDTEXT, 0, (LWRD)(char FAR*)"\rAnother line");
			Err = PixNoteItemSet(Item, PNI_ROTATION, 0, 2);
			Err = PixNoteItemAdd(HndlID, Item, 0);
			Err = PixNoteItemSet(Item, PNI_COLOR, 0, RGB(128,0,0));
	

/*
            Err = PixNoteItemNew(HndlID, &Item, NOTE_MODE_TEXT);
            Err = PixNoteItemSet(Item, PNI_ANCHOR, 0, MAKELONG(300,200));
            Err = PixNoteItemSet(Item, PNI_TEXT, 0, (LWRD)(char FAR *)"This is a text test");
			Err = PixNoteItemSet(Item, PNI_DRAWFLAGS, 0, NOTE_DRAW_OPAQUE);
			Err = PixNoteItemSet(Item, PNI_ALIGNFLAGS, 0, TA_RIGHT | TA_BOTTOM);
			Err = PixNoteItemSet(Item, PNI_FONTSIZE, 0, 40);
			Err = PixNoteItemSet(Item, PNI_ROTATION, 0, 3);
			Err = PixNoteItemSet(Item, PNI_LINEINCR, 0, 100);
			Err = PixNoteItemSet(Item, PNI_FONT, 0, 10);
            Err = PixNoteItemAdd(HndlID, Item, 0);
            Err = PixNoteItemSet(Item, PNI_COLOR, 0, RGB(128,0,0));
*/
	  
//			Err = PixNoteItemNew(HndlID, &Item, NOTE_MODE_REDACT);
//			Err = PixNoteItemSet(Item, PNI_ANCHOR, 0, MAKELONG(150,150));
//			Err = PixNoteItemSet(Item, PNI_BBOX_RIGHT, 0, MAKELONG(0,0));
//			Err = PixNoteItemSet(Item, PNI_BBOX_LEFT, 0, MAKELONG(100,100));
//			Err = PixNoteItemAdd(HndlID, Item, 0);
//			Err = PixNoteItemSet(Item, PNI_COLOR, 0, RGB(0,0,128));

            Err = PixNoteItemNew(HndlID, &Item, NOTE_MODE_POPUP);
            Err = PixNoteItemSet(Item, PNI_ANCHOR, 0, MAKELONG(300,100));
			Err = PixNoteItemSet(Item, PNI_TEXT, 0, (LWRD)(char FAR *)"This is a popup test");
			Err = PixNoteItemSet(Item, PNI_CAPTION, 0, (LWRD)(char FAR *)"A Caption");
			Err = PixNoteItemSet(Item, PNI_APPENDTEXT, 0, (LWRD)(char FAR *)"\r\nMore text");
            Err = PixNoteItemAdd(HndlID, Item, 0);

//			Err = PixNoteItemSetDefault(NOTE_MODE_POPUP, PNI_TEXT, 0, (LWRD)(char FAR *)"Default popup text.");
//			Err = PixNoteItemSetDefault(NOTE_MODE_POPUP, PNI_FONT, 0, (LWRD)&PopUpFont);
//			Err = PixNoteItemSetDefault(NOTE_MODE_POPUP, PNI_CAPTION, 0, (LWRD)(char FAR *)"Default caption");
													   
            Err = PixNoteItemNew(HndlID, &Item, NOTE_MODE_POPUP);
            Err = PixNoteItemSet(Item, PNI_ANCHOR, 0, MAKELONG(300,100));
//			Err = PixNoteItemSet(Item, PNI_TEXT, 0, (LWRD)(char FAR *)"This is a popup test");
//			Err = PixNoteItemSet(Item, PNI_CAPTION, 0, (LWRD)(char FAR *)"A Caption");
			Err = PixNoteItemSet(Item, PNI_APPENDTEXT, 0, (LWRD)(char FAR *)"\r\nMore text");
            Err = PixNoteItemAdd(HndlID, Item, 0);

			Err = PixNoteItemSetDefault(NOTE_MODE_REDLINE, PNI_EXTENDLINE, 0, MAKELONG(100,100));
			Err = PixNoteItemSetDefault(NOTE_MODE_REDLINE, PNI_EXTENDLINE, 0, MAKELONG(100,200));
			Err = PixNoteItemSetDefault(NOTE_MODE_REDLINE, PNI_EXTENDLINE, 0, MAKELONG(200,200));
			Err = PixNoteItemSetDefault(NOTE_MODE_REDLINE, PNI_EXTENDLINE, 0, MAKELONG(200,100));
  
			Err = PixNoteItemSetDefault(NOTE_MODE_REDLINE, PNI_COLOR, 0, RGB(255,0,0));

            Err = PixNoteItemNew(HndlID, &Item, NOTE_MODE_REDLINE);
			Err = PixNoteItemSet(Item, PNI_ANCHOR, 0, MAKELONG(100,100));
//			Err = PixNoteItemSet(Item, PNI_EXTENDLINE, 0, MAKELONG(100,100));
//			Err = PixNoteItemSet(Item, PNI_EXTENDLINE, 0, MAKELONG(100,200));
//			Err = PixNoteItemSet(Item, PNI_EXTENDLINE, 0, MAKELONG(200,200));
//			Err = PixNoteItemSet(Item, PNI_EXTENDLINE, 0, MAKELONG(200,100));
			Err = PixNoteItemSet(Item, PNI_THICKNESS, 0, (LONG)4);
			Err = PixNoteItemAdd(HndlID, Item, 0);
//			Err = PixNoteItemSet(Item, PNI_COLOR, 0, RGB(0, 128, 0));

            Err = PixNoteItemNew(HndlID, &Item, NOTE_MODE_REDLINE);
//			Err = PixNoteItemSet(Item, PNI_ANCHOR, 0, MAKELONG(300,100));
//			Err = PixNoteItemSet(Item, PNI_EXTENDLINE, 0, MAKELONG(100,100));
//			Err = PixNoteItemSet(Item, PNI_EXTENDLINE, 0, MAKELONG(100,200));
//			Err = PixNoteItemSet(Item, PNI_EXTENDLINE, 0, MAKELONG(200,200));
//			Err = PixNoteItemSet(Item, PNI_EXTENDLINE, 0, MAKELONG(200,100));
//			Err = PixNoteItemSet(Item, PNI_THICKNESS, 0, (LONG)2);
			Err = PixNoteItemAdd(HndlID, Item, 0);
//			Err = PixNoteItemSet(Item, PNI_COLOR, 0, RGB(0, 128, 128));
            }
#endif
		if(!Err)
			PixNoteGet(HndlID,PNG_TOTITEMS,&TotItems);
		if(!TotItems)
			PixNoteFree(HndlID,1);
		else {
			Scrn= GetDC(hWndMain);
			PixNoteScale(HndlID,hWndMain,Scrn,hPage,pSettings);
			ReleaseDC(hWndMain,Scrn);
			NoteHndl[0]= HndlID;
		}
	}
	return(Err);
}

int SaveAnnotations(BYTE FAR *FName) {
	int Err= 0;
	if(NoteHndl[0])
		Err= PixNoteSaveFileIF(NoteHndl[0],FName,1);
	return(Err);
}

void FixAnnoteMenu(HWND hWnd, PIXM_PAGE mPage)
{
	HMENU hMenu = GetMenu(hWnd);
	EnableMenuItem(hMenu, IDM_N_LOAD, MF_BYCOMMAND | 
		(mPage ? MF_ENABLED : (MF_DISABLED | MF_GRAYED)));
	EnableMenuItem(hMenu, IDM_N_EDIT, MF_BYCOMMAND | 
		(mPage ? MF_ENABLED : (MF_DISABLED | MF_GRAYED)));
	EnableMenuItem(hMenu, IDM_N_SAVE, MF_BYCOMMAND | 
		((mPage && NoteHndl[0]) ? MF_ENABLED : (MF_DISABLED | MF_GRAYED)));
	EnableMenuItem(hMenu, IDM_N_CLOSE, MF_BYCOMMAND | 
		((mPage && NoteHndl[0]) ? MF_ENABLED : (MF_DISABLED | MF_GRAYED)));
	EnableMenuItem(hMenu, IDM_N_REDRAW, MF_BYCOMMAND | 
		((mPage && NoteHndl[0]) ? MF_ENABLED : (MF_DISABLED | MF_GRAYED)));
}

/**EOF: NOTES.C**/
