/*>>keyflag<< "%n"***********************************************************
    "SMPLPAN.C"

    Copyright (c) 1993-95 Pixel Translations, Incorporated.
    All Rights Reserved.
    Confidential and Proprietary to Pixel Translations, Incorporated.

*****************************************************************************
  TLIB Keywords: %v=version, %d=file date, %f=file date and time, %t=time
 		 %w=who last, %l=lock status, %n=file name
*****************************************************************************/


/*>>keyflag<< * %n %f %l **/
/* SMPLPAN.C 26-Oct-95,10:41:14  */

/*>>keyflag<< "&(#)%n v%v %f" */
static char szVersionId[] = "&(#)SMPLPAN.C v6 26-Oct-95,10:41:14";


/* smplpan.c -- functions for pan window

*/

#ifndef WINDOWS
#define WINDOWS     		/* needed for PIXDFLT and PIXM */
#endif

#include "pixdflt.h"        /* ISIS header file (includes others) */
#include "pixm.h"			/* high-speed viewing (etc) module */
#include "smplview.h"		/* header for this sample */
#include "pixpan.h"			/* pan window library */
#include "smplpan.h"		/* pan window functions */

extern PIXM_PAGE mPage;
extern PIXM_SETTINGS pSettings;
PIXPAN hPixPan = 0;			/* pan window handle */
PIXPANFUNC lpfnCloseProc = 0;

extern char szAppName[];		/* class name for the window */
extern HINSTANCE hInst;
extern HWND hWndMain;

/****************************************************************************
    FUNCTION: ClosePanWindow
 ****************************************************************************/
int ClosePanWindow(void)
{
    if (lpfnCloseProc) {
	    FreeProcInstance((FARPROC)lpfnCloseProc);
		if (hPixPan)
		    PixPanTagSet(hPixPan, PIXPAN_TAG_CLOSEPROC, 0L);
	}

    if (hPixPan) {
        PixPanClose(hPixPan);
	    PixPanFree(hPixPan);
	    hPixPan = 0;
	}

    return 0;
}

/****************************************************************************
    FUNCTION: CreatePanWindow
 ****************************************************************************/
int CreatePanWindow(HWND hWnd)
{
    int iReturn;

    if (!hPixPan) {
        iReturn = PixPanNew(&hPixPan);
        if (iReturn != PIXPAN_SUCCESS)
	        return iReturn;
    }

    PixPanTagSet(hPixPan, PIXPAN_TAG_APPNAME, (INT32)(void FAR *)"Pan Window");
    PixPanTagSet(hPixPan, PIXPAN_TAG_PARENT, (INT32) hWnd);
    PixPanTagSet(hPixPan, PIXPAN_TAG_HWNDIMAGE, (INT32) hWnd);

	lpfnCloseProc = (PIXPANFUNC)MakeProcInstance(PanCloseFunc, hInst);
    PixPanTagSet(hPixPan, PIXPAN_TAG_CLOSEPROC, (INT32)lpfnCloseProc);

    PixPanTagSet(hPixPan, PIXPAN_TAG_HINST, (INT32)hInst);
}

/****************************************************************************
    FUNCTION: ShowPanWindow
 ****************************************************************************/
int ShowPanWindow()
{

    PixPanTagSet(hPixPan, PIXPAN_TAG_SETTINGS, (INT32)(void FAR *)pSettings);
    PixPanTagSet(hPixPan, PIXPAN_TAG_PIXMPAGE, (INT32)(void FAR *)mPage);

#ifdef OUTXX
    /* set position of pan window */
    PixPanTagSet(hPixPan, PIXPAN_TAG_XPOSITION,xx);
    PixPanTagSet(hPixPan, PIXPAN_TAG_YPOSITION,xx );
    PixPanTagSet(hPixPan, PIXPAN_TAG_WIDTH,xx );
    PixPanTagSet(hPixPan, PIXPAN_TAG_HEIGHT,xx );
#endif

    PixPanTagSet(hPixPan, PIXPAN_TAG_SCALING, (INT32)TAG_SCALING_BINARY);

    PixPanOpen(hPixPan);
    return 0;
}

/****************************************************************************
    FUNCTION: NewImagePanWindow
 ****************************************************************************/
int NewImagePanWindow()
{
    INT32 lValue;
    HWND hWndImage;

    if (hPixPan) {
        PixPanTagGet(hPixPan, PIXPAN_TAG_HWNDIMAGE, &lValue);
        hWndImage = (HWND)lValue;

        PixPanTagSet(hPixPan, PIXPAN_TAG_SETTINGS,(INT32)(void FAR *)pSettings);
        PixPanTagSet(hPixPan, PIXPAN_TAG_PIXMPAGE,(INT32)(void FAR *)mPage);

        /* InvalidateRect(hWndImage, NULL, FALSE); */
    }

    return 0;

}

/****************************************************************************
    FUNCTION: PanCloseFunc
 ****************************************************************************/
int PUBLIC_FUNC PanCloseFunc(PIXPAN hPixPan)
{
    INT32 lValue;
	HWND hWnd;

    PixPanTagGet(hPixPan, PIXPAN_TAG_PARENT, &lValue);
    hWnd = (HWND)lValue;
    CheckMenuItem(GetMenu(hWnd), IDM_O_PANWINDOW, MF_BYCOMMAND | MF_UNCHECKED);
    return TRUE;
}

