/*>>keyflag<< "%n"***********************************************************
    "SMPLPRNT.C"

    Copyright (c) 1993-95 Pixel Translations, Incorporated.
    All Rights Reserved.
    Confidential and Proprietary to Pixel Translations, Incorporated.

	Much of the printing part of Smplview
*****************************************************************************
  TLIB Keywords: %v=version, %d=file date, %f=file date and time, %t=time
 		 %w=who last, %l=lock status, %n=file name
*****************************************************************************/


/*>>keyflag<< * %n %f %l **/
/* SMPLPRNT.C 04-Mar-96,11:12:38  */

/*>>keyflag<< "&(#)%n v%v %f" */
static char szVersionId[] = "&(#)SMPLPRNT.C v21 04-Mar-96,11:12:38";

#include <pixwin.h>
#include <pixdflt.h>
#include <pixm.h>
#include "smplprnt.h"
#include <commdlg.h>
#include "smplview.h" /* for Check */
#ifndef WIN32
#include <print.h>
#endif

/*#define DOTEST*/

FARPROC lpfnAbortProc = NULL;
FARPROC lpfnPrintDlgProc = NULL;

HWND hDlgPrint = NULL;

BOOL bError;
BOOL bUserAbort;
char szNull[] = "";

#pragma alloc_text(_PRINT, PrintAbortProc, PrintDlgProc)

static PRINTDLG pd;
static UINT32 dwPrintAccel;
static INT32 dwPrintJob;

extern PIXM_PAINT_CALLBACKDESC prpcbRectCallBack;

int PrintInitialize(void)
{
	PixMemSet(&pd, 0, sizeof(pd));
	pd.lStructSize = sizeof(pd);

	return PIX_SUCCESS;
}

int PrintDone(void)
{
	if (pd.hDevMode) {
		GlobalFree(pd.hDevMode);
		pd.hDevMode = 0;
	}
	if (pd.hDevNames) {
		GlobalFree(pd.hDevNames);
		pd.hDevNames = 0;
	}

	return PIX_SUCCESS;
}

int PrintSetup(HWND hWnd)
{
	pd.hwndOwner = hWnd;
	pd.Flags = PD_PRINTSETUP;

	PrintDlg(&pd);

	return PIX_SUCCESS;
}

#ifdef INCLUDE_PRINT_TEST

int PrintTestPage(PIXM_PAGE mPage, PIXM_SETTINGS pSettings,
	char FAR *szAppName, HINSTANCE hInst,
	RECT FAR *prectDest, RECT FAR *prectClip)
{
	int bError = FALSE;
	char buffer[200];
   	PIXM_SETTINGS pTemp;
	DOCINFO doc;
	RECT rcPrintArea;

	doc.cbSize = sizeof(doc);
	doc.lpszDocName = szAppName;
	doc.lpszOutput = 0;
#ifdef WIN32
	doc.lpszDatatype = "EMF";
	doc.fwType = 0;
#endif
	if (StartDoc(pd.hDC, &doc) <= 0)
		bError = TRUE;

    PixmSettingsNew(&pTemp, 1);
    PixmSettingsDuplicate(pTemp, 0, pSettings, 0, 1);

	StartPage(pd.hDC);
    PixmPrintJobPageStart(dwPrintJob, 0);

	SetRect(&rcPrintArea, 0, 0,
		GetDeviceCaps(pd.hDC, HORZRES),
		GetDeviceCaps(pd.hDC, VERTRES));

	while (!bError && !bUserAbort) {
		RECT rcBand, rcActual;
		BOOL bDoGraphics;

#ifdef WIN32
		rcBand = rcPrintArea;
#else
		Escape(pd.hDC, NEXTBAND, 0, (LPSTR)NULL, &rcBand);
		if (IsRectEmpty((RECT FAR *)&rcBand))
			break;
#endif

		PixmPrintJobBandStart(dwPrintJob, &bDoGraphics);

		DPtoLP(pd.hDC, (POINT FAR *)&rcBand, 2);

		if (bDoGraphics &&
			IntersectRect((RECT FAR *)&rcActual, (RECT FAR *)&rcBand, prectClip)) {
			UINT32 xScale, yScale, rot, xOff, yOff;
			int width = 1696;
			int length = 2175;
			int xLoc = 1049;
			int yLoc = 1642;
			int x, y;
			char buffer[100];
			if (PixmRectPaint(0, pd.hDC,       	/* DC, Window 				*/
				mPage, pTemp, 0,				/* image data & settings 	*/
				prectDest, (RECT FAR *)&rcActual, /* repaint area & posn 	*/
				0, 0,                         	/* no buffer passed 		*/
												/* accel if possible 		*/
				dwPrintJob|dwPrintAccel|PIXM_PAINT_FAST|PIXM_PAINT_ACCELAUTO,
				0, 0))
				bError = TRUE;
			PixmSettingsGet(pTemp, TAG_SCALE_X, 0, &xScale);
			PixmSettingsGet(pTemp, TAG_SCALE_Y, 0, &yScale);
			PixmSettingsGet(pTemp, TAG_XPOSITION, 0, &xOff);
			PixmSettingsGet(pTemp, TAG_YPOSITION, 0, &yOff);
	        PixmSettingsGet(pTemp, TAG_ORIENTATION, 0, &rot);
			switch(rot) {
				case TAG_ORIENTATION_PORT:
					x = xLoc; y = yLoc;
					break;
				case TAG_ORIENTATION_LAND:
					x = length - yLoc;
					y = xLoc;
					break;
				case TAG_ORIENTATION_180:
					x = width - xLoc;
					y = length - yLoc;
					break;
				case TAG_ORIENTATION_270:
					x = yLoc;
					y = width - xLoc;
					break;
				case TAG_ORIENTATION_PORTM:
					x = width - xLoc;
					y = yLoc;
					break;
				case TAG_ORIENTATION_LANDM:
					x = yLoc;
					y = xLoc;
					break;
				case TAG_ORIENTATION_180M:
					x = xLoc;
					y = length - yLoc;
					break;
				case TAG_ORIENTATION_270M:
					x = length - yLoc;
					y = width - xLoc;
					break;
			}
			x = (int)(((long)x * (long)PIXM_RAT_NUM(xScale) /
					(long)PIXM_RAT_DEN(xScale)) - (int)(UINT16)xOff);
			y = (int)(((long)y * (long)PIXM_RAT_NUM(yScale) /
					(long)PIXM_RAT_DEN(yScale)) - (int)(UINT16)yOff);
			wsprintf(buffer, "scales: x=0x%lx, y=0x%lx\n", xScale, yScale);
			OutputDebugString(buffer);
			wsprintf(buffer, "loc = (%d,%d)\n", x, y);
			OutputDebugString(buffer);
			wsprintf(buffer, "xoff = %lu(%d), yoff = %lu(%d)\n",
				xOff, yOff, (int)(UINT16)xOff, (int)(UINT16)yOff);
			OutputDebugString(buffer);
			MoveTo(pd.hDC, x-150, y-150);
			LineTo(pd.hDC, x+150, y+150);
			MoveTo(pd.hDC, x-150, y+150);
			LineTo(pd.hDC, x+150, y-150);
			}
		PixmPrintJobBandDone(dwPrintJob);

#ifdef WIN32
		break;
#endif
	}

	if (!bError && !bUserAbort) {
		PixmPrintJobPageDone(dwPrintJob);
		EndPage(pd.hDC);
		EndDoc(pd.hDC);
	} else {
		PixmPrintJobPageAbort(dwPrintJob);
		EndPage(pd.hDC);
		AbortDoc(pd.hDC);
	}

	return bError;
}

int PrintTest(PIXM_PAGE mPage, PIXM_SETTINGS pSettings, HWND hWnd,
	char FAR *szAppName, INT32 lScale)
{
	HINSTANCE hInst = GetWindowInstance(hWnd);

	pd.hwndOwner = hWnd;
	pd.Flags = 	PD_PAGENUMS |
				PD_NOSELECTION |
				PD_RETURNDC |
				PD_USEDEVMODECOPIES;

	pd.nMinPage = 1;
	pd.nMaxPage = 14;
	pd.nFromPage = 1;
	pd.nToPage = 14;
	if (PrintDlg(&pd) != 0) {
    	PIXM_SETTINGS pTemp;
    	RECT rcPrintArea, rcClipArea;
		DEVNAMES FAR *lpDevNames;
		char lpszPrintName[80];

		/* see if an accelerator exists for this printer */

		lpDevNames = (DEVNAMES FAR *)GlobalLock(pd.hDevNames);
		PixMemStrcpy(lpszPrintName, (char FAR *)lpDevNames + lpDevNames->wDeviceOffset);
		PixMemStrcat(lpszPrintName, ",");
		PixMemStrcat(lpszPrintName, (char FAR *)lpDevNames + lpDevNames->wDriverOffset);
		PixMemStrcat(lpszPrintName, ",");
		PixMemStrcat(lpszPrintName, (char FAR *)lpDevNames + lpDevNames->wOutputOffset);
		PixmPrintGetAccel(&dwPrintAccel, lpszPrintName);

		GlobalUnlock(pd.hDevNames);

	    PixmSettingsNew(&pTemp, 1);
	    PixmSettingsSet(pTemp, TAG_OVERSCAN, 0, 0, TAG_OVERSCAN_WHITE);
	    PixmSettingsSet(pTemp, TAG_SCALE_X, 0, 0, lScale);
        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, TAG_ORIENTATION_PORT);

		PixmPrintJobNew(&dwPrintJob);
		PixmPrintJobSet(dwPrintJob, TAG_PRINTACCEL, dwPrintAccel);
		PixmPrintJobSet(dwPrintJob, TAG_HDC, pd.hDC);

		bError = FALSE;		/* no errors yet */
		bUserAbort = FALSE;	/* user hasn't aborted */

		lpfnPrintDlgProc = MakeProcInstance(PrintDlgProc, hInst);
		lpfnAbortProc    = MakeProcInstance(PrintAbortProc, hInst);

		if (hDlgPrint = CreateDialogParam(hInst, "PRTDLG", hWnd, lpfnPrintDlgProc, 0)) {
			SetWindowText(hDlgPrint, szAppName);
			EnableWindow(hWnd, FALSE);	/* disable parent */
			if (SetAbortProc(pd.hDC, lpfnAbortProc) > 0) { 
				int nHRes = GetDeviceCaps(pd.hDC, HORZRES);
				int nVRes = GetDeviceCaps(pd.hDC, VERTRES);

			  switch(pd.nFromPage) {

			    case 1:
				/* NORMAL FIT TO PAGE */
				SetRect(&rcPrintArea, 0, 0, nHRes, nVRes);
				SetRect(&rcClipArea, 0, 0, nHRes, nVRes);
				PrintTestPage(mPage, pTemp, szAppName, hInst,
					&rcPrintArea, &rcClipArea);
				if (pd.nToPage == 1)
					break;

			    case 2:
				/* FIT TO PAGE SCALE, CLIP RECT IN LOWER RIGHT QUADRANT */
				SetRect(&rcPrintArea, 0, 0, nHRes, nVRes);
				SetRect(&rcClipArea, nHRes / 2, (int)((long)nVRes * 11 / 16),
					(int)((long)nHRes * 3 / 4), (int)((long)nVRes * 13 / 16));
				PrintTestPage(mPage, pTemp, szAppName, hInst,
					&rcPrintArea, &rcClipArea);
				if (pd.nToPage == 2)
					break;

			    case 3:
				/* SCALE 3 * FIT TO PAGE, OFFSET AND CLIP SO THAT */
				/*  IMAGE IS SIMILAR TO PREVIOUS */
				PixmSettingsSet(pTemp, TAG_XPOSITION, 0, 0, (int)(5L * nHRes / 4));
				PixmSettingsSet(pTemp, TAG_YPOSITION, 0, 0, (int)(3L * nVRes / 2));
				SetRect(&rcPrintArea, 0, 0, (int)((long)nHRes * 3),
					(int)((long)nVRes * 3));
				SetRect(&rcClipArea, nHRes / 4, (int)((long)nVRes * 3 / 8),
					(int)((long)nHRes * 5 / 8), (int)((long)nVRes * 3 / 4));
				PrintTestPage(mPage, pTemp, szAppName, hInst,
					&rcPrintArea, &rcClipArea);
				PixmSettingsSet(pTemp, TAG_XPOSITION, 0, 0, 0);
				PixmSettingsSet(pTemp, TAG_YPOSITION, 0, 0, 0);
				if (pd.nToPage == 3)
					break;

			    case 4:
				/* SCALE 2 * FIT TO PAGE, OFFSET AND CLIP SO THAT
				     IMAGE IS SIMILAR TO PREVIOUS */
				PixmSettingsSet(pTemp, TAG_XPOSITION, 0, 0, 11L * nHRes / 16);
				PixmSettingsSet(pTemp, TAG_YPOSITION, 0, 0, nVRes);
				SetRect(&rcPrintArea, 0, 0, nHRes * 2, nVRes * 2);
				SetRect(&rcClipArea, nHRes / 4, (int)((long)nVRes * 3 / 8),
					(int)((long)nHRes * 5 / 8), (int)((long)nVRes * 3 / 4));
				PrintTestPage(mPage, pTemp, szAppName, hInst,
					&rcPrintArea, &rcClipArea);
				PixmSettingsSet(pTemp, TAG_XPOSITION, 0, 0, 0);
				PixmSettingsSet(pTemp, TAG_YPOSITION, 0, 0, 0);
				if (pd.nToPage == 4)
					break;

			    case 5:
				/* SCALE 1 * FIT TO PAGE, ORIENTATION = LAND, CLIP SIMILAR TO
				    SECOND TEST */
		        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, TAG_ORIENTATION_LAND);
				SetRect(&rcPrintArea, 0, 0, nHRes, nVRes);
				SetRect(&rcClipArea, (int)((long)nHRes * 3 / 16), (int)((long)nVRes / 4),
					(int)((long)nHRes * 5 / 16), (int)((long)nVRes * 3 / 8));
				PrintTestPage(mPage, pTemp, szAppName, hInst,
					&rcPrintArea, &rcClipArea);
		        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, TAG_ORIENTATION_PORT);
				if (pd.nToPage == 5)
					break;

			    case 6:
				/* SCALE 2 * FIT TO PAGE, ORIENTATION = LAND, CLIP SIMILAR TO
				    SECOND TEST */
		        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, TAG_ORIENTATION_LAND);
				SetRect(&rcPrintArea, 0, 0, nHRes * 2, nVRes * 2);
				SetRect(&rcClipArea, (int)((long)nHRes * 3 / 8), nVRes / 2,
					(int)((long)nHRes * 5 / 8), (int)((long)nVRes * 3 / 4));
				PrintTestPage(mPage, pTemp, szAppName, hInst,
					&rcPrintArea, &rcClipArea);
		        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, TAG_ORIENTATION_PORT);
				if (pd.nToPage == 6)
					break;

			    case 7:
				/* SCALE 5 * FIT TO PAGE, ORIENTATION = LAND, MIDDLE OF TOP
				    OF IMAGE IS VISIBLE */
		        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, TAG_ORIENTATION_LAND);
				SetRect(&rcPrintArea, 0, 0, nHRes * 5, nVRes * 5);
				SetRect(&rcClipArea, nHRes / 16, nVRes / 16,
					(int)((long)nHRes * 9 / 16), (int)((long)nVRes * 5 / 8));
				PixmSettingsSet(pTemp, TAG_XPOSITION, 0, 0, 9L * nHRes / 2);
				PixmSettingsSet(pTemp, TAG_YPOSITION, 0, 0, 5L * nVRes / 4);
				PrintTestPage(mPage, pTemp, szAppName, hInst,
					&rcPrintArea, &rcClipArea);
				PixmSettingsSet(pTemp, TAG_XPOSITION, 0, 0, 0);
				PixmSettingsSet(pTemp, TAG_YPOSITION, 0, 0, 0);
		        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, TAG_ORIENTATION_PORT);
				if (pd.nToPage == 7)
					break;

			    case 8:
				/**/
		        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, TAG_ORIENTATION_180);
				SetRect(&rcPrintArea, 0, 0, nHRes, nVRes);
				SetRect(&rcClipArea, nHRes / 16, nVRes / 16,
					(int)((long)nHRes * 9 / 16), (int)((long)nVRes * 5 / 8));
				PrintTestPage(mPage, pTemp, szAppName, hInst,
					&rcPrintArea, &rcClipArea);
		        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, TAG_ORIENTATION_PORT);
				if (pd.nToPage == 8)
					break;

			    case 9:
				/**/
		        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, TAG_ORIENTATION_270);
				SetRect(&rcPrintArea, 0, 0, nHRes, nVRes);
				SetRect(&rcClipArea, nHRes / 16, nVRes / 16,
					(int)((long)nHRes * 9 / 16), (int)((long)nVRes * 5 / 8));
				PrintTestPage(mPage, pTemp, szAppName, hInst,
					&rcPrintArea, &rcClipArea);
		        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, TAG_ORIENTATION_PORT);
				if (pd.nToPage == 9)
					break;

			    case 10:
				/**/
		        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, TAG_ORIENTATION_PORTM);
				SetRect(&rcPrintArea, 0, 0, nHRes, nVRes);
				SetRect(&rcClipArea, nHRes / 16, nVRes / 16,
					(int)((long)nHRes * 9 / 16), (int)((long)nVRes * 5 / 8));
				PrintTestPage(mPage, pTemp, szAppName, hInst,
					&rcPrintArea, &rcClipArea);
		        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, TAG_ORIENTATION_PORT);
				if (pd.nToPage == 10)
					break;

			    case 11:
		        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, TAG_ORIENTATION_LANDM);
				SetRect(&rcPrintArea, 0, 0, nHRes, nVRes);
				SetRect(&rcClipArea, nHRes / 16, nVRes / 16,
					(int)((long)nHRes * 9 / 16), (int)((long)nVRes * 5 / 8));
				PrintTestPage(mPage, pTemp, szAppName, hInst,
					&rcPrintArea, &rcClipArea);
		        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, TAG_ORIENTATION_PORT);
				if (pd.nToPage == 11)
					break;

			    case 12:
		        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, TAG_ORIENTATION_180M);
				SetRect(&rcPrintArea, 0, 0, nHRes, nVRes);
				SetRect(&rcClipArea, nHRes / 16, nVRes / 16,
					(int)((long)nHRes * 9 / 16), (int)((long)nVRes * 5 / 8));
				PrintTestPage(mPage, pTemp, szAppName, hInst,
					&rcPrintArea, &rcClipArea);
		        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, TAG_ORIENTATION_PORT);
				if (pd.nToPage == 12)
					break;

			    case 13:
		        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, TAG_ORIENTATION_270M);
				SetRect(&rcPrintArea, 0, 0, nHRes, nVRes);
				SetRect(&rcClipArea, nHRes / 16, nVRes / 16,
					(int)((long)nHRes * 9 / 16), (int)((long)nVRes * 5 / 8));
				PrintTestPage(mPage, pTemp, szAppName, hInst,
					&rcPrintArea, &rcClipArea);
		        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, TAG_ORIENTATION_PORT);
				if (pd.nToPage == 13)
					break;

			    case 14:
			    PixmSettingsSet(pTemp, TAG_SCALE_X, 0, 0, PIXM_RAT(8,7));
			    PixmSettingsSet(pTemp, TAG_SCALE_Y, 0, 0, PIXM_RAT(8,7));
				PixmSettingsSet(pTemp, TAG_XPOSITION, 0, 0, 100);
				PixmSettingsSet(pTemp, TAG_YPOSITION, 0, 0, 100);
				SetRect(&rcPrintArea, 0, 0, nHRes, nVRes);
				SetRect(&rcClipArea, 800, 1000, 1600, 2000);
				PrintTestPage(mPage, pTemp, szAppName, hInst,
					&rcPrintArea, &rcClipArea);
			    PixmSettingsSet(pTemp, TAG_SCALE_X, 0, 0, lScale);
				PixmSettingsSet(pTemp, TAG_XPOSITION, 0, 0, 0);
				PixmSettingsSet(pTemp, TAG_YPOSITION, 0, 0, 0);
				if (pd.nToPage == 14)
					break;

			  }

			}
			  else
				bError = TRUE;
		} else
			bError = TRUE;

		if (!bError && !bUserAbort) {
			PixmPrintJobDone(dwPrintJob, 0);
		} else {
			PixmPrintJobAbort(dwPrintJob, 0);
		}

		if (hDlgPrint) {
			EnableWindow(hWnd, TRUE);/* turn parent back on */
			DestroyWindow(hDlgPrint);/* toast out dialog */
		}

		FreeProcInstance(lpfnAbortProc);
		FreeProcInstance(lpfnPrintDlgProc);

		DeleteDC(pd.hDC);

	    PixmSettingsFree(pTemp);

	}

	if (bUserAbort)
		return PIX_ERR_CANCEL;
	if (bError)
		return PIX_ERR_SOFTWARE; /* should look up better code */
	return PIX_SUCCESS;
}

#endif

int PrintPage(PIXM_PAGE mPage, PIXM_SETTINGS pSettings, HWND hWnd,
	char FAR *szAppName, INT32 lScale)
{
	HINSTANCE hInst = GetWindowInstance(hWnd);

	pd.hwndOwner = hWnd;
	pd.Flags = 	PD_NOPAGENUMS |
				PD_NOSELECTION |
				PD_RETURNDC |
				PD_USEDEVMODECOPIES;

	if (PrintDlg(&pd) != 0) {
    	PIXM_SETTINGS pTemp;
    	RECT rcPrintArea;
		DEVNAMES FAR *lpDevNames;
		char lpszPrintName[80];
		INT32 lValue;

		/* see if an accelerator exists for this printer */

		lpDevNames = (DEVNAMES FAR *)GlobalLock(pd.hDevNames);
		PixMemStrcpy(lpszPrintName, (char FAR *)lpDevNames + lpDevNames->wDeviceOffset);
		PixMemStrcat(lpszPrintName, ",");
		PixMemStrcat(lpszPrintName, (char FAR *)lpDevNames + lpDevNames->wDriverOffset);
		PixMemStrcat(lpszPrintName, ",");
		PixMemStrcat(lpszPrintName, (char FAR *)lpDevNames + lpDevNames->wOutputOffset);
		PixmPrintGetAccel(&dwPrintAccel, lpszPrintName);
		GlobalUnlock(pd.hDevNames);

	    PixmSettingsNew(&pTemp, 1);
	    PixmSettingsSet(pTemp, TAG_OVERSCAN, 0, 0, TAG_OVERSCAN_WHITE);
	    PixmSettingsSet(pTemp, TAG_SCALE_X, 0, 0, lScale);
        PixmSettingsGet(pSettings, TAG_ORIENTATION, 0, &lValue);
        PixmSettingsSet(pTemp, TAG_ORIENTATION, 0, 0, lValue);

		if (pd.hDevMode) {
			LPDEVMODE lpDevMode;
			char FAR *lpData;

			lpData = GlobalLock(pd.hDevMode);
			if (lpData) {
				lpDevMode = (LPDEVMODE)lpData;
				if ((lpDevMode->dmFields & DM_ORIENTATION) && 
					(lpDevMode->dmOrientation == DMORIENT_LANDSCAPE)) {
				
					LPDEVNAMES lpDevNames;
					LPSTR lpszDriverName, lpszDeviceName, lpszPortName;
	
					lpDevNames = (LPDEVNAMES)GlobalLock(pd.hDevNames);
					lpszDriverName = (LPSTR)lpDevNames + lpDevNames->wDriverOffset;
					lpszDeviceName = (LPSTR)lpDevNames + lpDevNames->wDeviceOffset;
					lpszPortName = (LPSTR)lpDevNames + lpDevNames->wOutputOffset;
					lpDevMode->dmOrientation = DMORIENT_PORTRAIT;
					PixmSettingsSet(pTemp, TAG_ROTATION, 0, 0, TAG_ROTATION_COUNTERCLOCKWISE);
					DeleteDC(pd.hDC);
					pd.hDC = CreateDC(lpszDriverName, lpszDeviceName, lpszPortName, lpDevMode);
				}
				GlobalUnlock(pd.hDevMode);
				GlobalUnlock(pd.hDevNames);
			}
		}

		PixmPrintJobNew(&dwPrintJob);
		PixmPrintJobSet(dwPrintJob, TAG_PRINTACCEL, dwPrintAccel);
		PixmPrintJobSet(dwPrintJob, TAG_HDC, (INT32)pd.hDC);

		bError = FALSE;		/* no errors yet */
		bUserAbort = FALSE;	/* user hasn't aborted */

		lpfnPrintDlgProc = MakeProcInstance(PrintDlgProc, hInst);
		lpfnAbortProc    = MakeProcInstance(PrintAbortProc, hInst);

		if (hDlgPrint = CreateDialogParam(hInst, "PRTDLG", hWnd, lpfnPrintDlgProc, 0)) {
			DOCINFO doc;

			SetWindowText(hDlgPrint, szAppName);
			EnableWindow(hWnd, FALSE);	/* disable parent */
			doc.cbSize = sizeof(doc);
			doc.lpszDocName = szAppName;
			doc.lpszOutput = 0;
#ifdef WIN32
			doc.lpszDatatype = "EMF";
			doc.fwType = 0;
#endif
			if (SetAbortProc(pd.hDC, lpfnAbortProc) <= 0 || 
				StartDoc(pd.hDC, &doc) <= 0)
				bError = TRUE;
		} else
	    	bError = TRUE;

		StartPage(pd.hDC);
	    PixmPrintJobPageStart(dwPrintJob, 0);

		SetRect(&rcPrintArea, 0, 0,
			GetDeviceCaps(pd.hDC, HORZRES),
			GetDeviceCaps(pd.hDC, VERTRES));

		while (!bError && !bUserAbort) {
			RECT rcRect;
			BOOL bDoGraphics;

#ifdef WIN32
			rcRect = rcPrintArea;
#else
			Escape(pd.hDC, NEXTBAND, 0, (LPSTR)NULL, &rcRect);
			if (IsRectEmpty(&rcRect))
				break;
#endif

			PixmPrintJobBandStart(dwPrintJob, &bDoGraphics);

			DPtoLP(pd.hDC, (POINT FAR *)&rcRect, 2);

			if (bDoGraphics)
				if (PixmRectPaint(0, pd.hDC,   	/* DC, Window 				*/
	              mPage, pTemp, 0,             	/* image data & settings 	*/
	              &rcPrintArea, &rcRect,       	/* repaint area & posn 		*/
	              0, 0,                        	/* no buffer passed 		*/
		      									/* accel if possible 		*/
	              dwPrintJob|dwPrintAccel|PIXM_PAINT_FAST|PIXM_PAINT_ACCELAUTO,	
	              0, prpcbRectCallBack))
	              bError = TRUE;
	              
            PixmPrintJobBandDone(dwPrintJob);

#ifdef WIN32
			break;
#endif
        }

		if (!bError && !bUserAbort) {
			PixmPrintJobPageDone(dwPrintJob);
			EndPage(pd.hDC);
			PixmPrintJobDone(dwPrintJob, 0);
			EndDoc(pd.hDC);
		} else {
			PixmPrintJobPageAbort(dwPrintJob);
			EndPage(pd.hDC);
			PixmPrintJobAbort(dwPrintJob, 0);
			AbortDoc(pd.hDC);
		}

		if (hDlgPrint) {
			EnableWindow(hWnd, TRUE);/* turn parent back on */
			DestroyWindow(hDlgPrint);/* toast out dialog */
		}

		FreeProcInstance(lpfnAbortProc);
		FreeProcInstance(lpfnPrintDlgProc);

		DeleteDC(pd.hDC);

	    PixmSettingsFree(pTemp);
	}

	if (bUserAbort)
		return PIX_ERR_CANCEL;
	if (bError)
		return PIX_ERR_SOFTWARE;
	return PIX_SUCCESS;
}



/*
 * PrintDlgProc()	printing dialog proc (has a cancle button on it)
 *
 * globals used:
 *	szAppName	name of the app for dialog caption
 *	bUserAbort	sets this when the user hits cancel
 *	hDlgPrint
 */

BOOL PUBLIC_FUNC PrintDlgProc (HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	switch (iMessage) {
	case WM_INITDIALOG:

		EnableMenuItem(GetSystemMenu(hDlg, FALSE), SC_CLOSE, MF_GRAYED);
		break;

	case WM_COMMAND:
		bUserAbort = TRUE;
		EnableWindow(GetParent(hDlg), TRUE);
		DestroyWindow(hDlg);
		hDlgPrint = 0;
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/*
 * AbortProc()	printing abort procedure
 *
 * globals used:
 *	bUserAbort 	indicates the user hit CANCLE on the print dialog
 *	hDlgPrint	handle of the print dialog
 *
 */

BOOL PUBLIC_FUNC PrintAbortProc (HDC hPrnDC, short nCode)
{
	MSG   msg;

	while (!bUserAbort && PeekMessage (&msg, NULL, 0, 0, PM_REMOVE)) {
		if (!hDlgPrint || !IsDialogMessage(hDlgPrint, &msg)) {
			TranslateMessage (&msg);
			DispatchMessage (&msg);
		}
	}
	return !bUserAbort;
}
